{
  This unit contains object, which builds a collection on the basis of
  a database, containing not lines, and collection of lines. In each line
  of collection is one field of a database.
}

Unit
  MakeDB;

Interface

Uses
  DBServ, Objects;

Type
  PDataBase = ^TDataBase;
  TDataBase = Object(TDBFile)
    Function BuildRecCollection: PCollection; Virtual;
    Function GetHeader(Pos: Integer): String; Virtual;
End;

Implementation

Uses
  Tools, Arc;

Function TDataBase.BuildRecCollection: PCollection;
Var
  C, iCol: PCollection;
  S: String;
  Buf: TBuffer;

  Function BuildNormalRec: PCollection;
  Var
    P,D: String;
    i,j: Byte;
    InnerCol: PNoSortedStringCollection; { Here she native! }

    Procedure ToStr(Item: Pointer);
    Begin
      With PField(Item)^ do
      Begin
        D := LongCopy(Buf, i, Length);
        if What = ftDate then ToDate(D);
        P := D;
        if Length < System.Length(Name) then
           P := P + Space(System.Length(Name) - Length);
        Inc(i, Length);
      End;
      InnerCol^.Insert(NewStr(P+''));
    End;

  Begin
    InnerCol := New(PNoSortedStringCollection, Init(5, 2));
    P := Buf[0] + #$20#179;
    InnerCol^.Insert(NewStr(P));
    i := 1;
    With Fields^ do
    For j := 0 to Count - 1 do
    Begin
      P := '';
      ToStr(At(j));
    End;
    BuildNormalRec := InnerCol;
  End;

Var
  M: LongInt;
Begin
  C := New(PCollection, Init(RecCount, 0));
  M := MemAvail;
  if MemAvail < GetSize then
  Begin
    System.Write('There is not enough memory! Press ENTER for EXIT!'#7#7);
    ReadLn;
    Halt;
  End;
  Seek(StartPos);
  While True do
  Begin
    if Not ReadRec(Buf) then
       Break;
    iCol := BuildNormalRec;
    C^.Insert(iCol);
  End;
  BuildRecCollection := C;
  Seek(0);
End;

Function TDataBase.GetHeader(Pos: Integer): String;
Var
  S: String;
  i: Byte;
Begin
  S := 'Del'#179;
  For i := Pos to Fields^.Count - 1 do
  With PField(Fields^.At(i))^ do
  Begin
    if System.Length(Name) < Length then
       S := S + Space(Length - System.Length(Name));
    if What = ftDate then S := S + '  ';
    S := S + Name + #179;
  End;
  Dec(S[0]);
  GetHeader := S;
End;

End.