{***********************************************************}
{* Data base file viewer.                                  *}
{* (C) ᫠ 㫨.  " த "      *}
{* All Rights Reserved.                                    *}
{* FidoNet: 2:5003/20                                      *}
{* Relcom: root@snbank.komi.su                             *}
{***********************************************************}

Uses
  Objects, DBServ, DBVDlg, TimeOut, Menus, App, Dialogs,
  Views, Drivers, MsgBox, IniServ;

{$IFNDEF DPMI}
  This program needs to be compiled in a protected mode
{$ENDIF}

Type
   PDBView = ^TDBView;
   TDBView = Object(TGadGetsApp)
     Procedure Run; Virtual;
     Procedure InitStatusLine; Virtual;
   End;

{  TDBView OBJECT }
Procedure TDBView.InitStatusLine;
Var
  R: TRect;
Begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  StatusLine := New(PStatusLine, Init(R,
            NewStatusDef(0, $FFFF,
              NewStatusKey('~F1~ Help', kbF1, cmHelp,
              NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
              NewStatusKey('~F2~ ', kbF2, cmToBin,
              NewStatusKey('~F4~ ', kbF4, cmHead,
              NewStatusKey('~F5~ Text', kbF5, cmText,
              NewStatusKey('~F10~ Get Info', kbF10, cmInfo,
              Nil)))))),
            Nil)));
End;


Procedure TDBView.Run;
Var
  R: TRect;
  D: PDBViewDialog;
  F: PDBFile;
  C: PCollection;
  S: String;
  Pn: Pointer;
Begin
  S := ParamStr(1);
  if Pos('.', S) = 0 then
     S := S + '.dbf';
  F := New(PDBFile, Init(S, stOpenRead, 2048));
  Case F^.Status of
   stNoDataBase: Begin
                   Pn := @S;
                   MessageBox(^C'File %s is not database.', @Pn, mfError + mfOkButton);
                   Dispose(F, Done);
                   Exit;
                 End;
   stOk: ;
   else
     Begin
       Pn := @S;
       MessageBox(^C'Can''t open file %s.', @Pn, mfError + mfOkButton);
       Dispose(F, Done);
       Exit;
     End;
   End;
  WaitPlease;
  C := F^.BuildRecCollection;
  S := F^.GetHeader(0);
  D := New(PDBViewDialog, Init(F, ParamStr(1), S));
  D^.LB^.NewList(C);
  DeleteWait;
  ExecuteDialog(D, Nil);
  Dispose(F, Done);
End;

Var
  T: TDBView;
Begin
  LoadProfile('tvdbview.ini');
  if ParamCount = 0 then
  Begin
    PrintStr('Usage: TVDBView <Filename>'#13#10#7);
    Exit;
  End;
  T.Init;
  T.Run;
  T.Done;
End.