Unit
  ViewDB;

Interface

Uses
  Dialogs, DBVDlg, MakeDB, Drivers, Objects;

Type
  PDBListBox = ^TDBListBox;
  TDBListBox = Object(TListBox)
    Function GetText(Item: Integer; MaxLen: Integer): String; virtual;
  End;


  PDBDialog = ^TDBDialog;
  TDBDialog = Object(TDBViewDialog)
    Pos: Integer; { Current field }
    Rct: TRect;
    T: PFieldStaticText;
    Constructor Init(F: PDataBase; ATitle: String);
    Destructor Done; Virtual;
    Procedure HandleEvent(var Event: TEvent); Virtual;
    Procedure RedrawHeader;
  End;

Implementation

Uses
  Views, App;

Constructor TDBDialog.Init;
Var
  R: TRect;
  P: PScrollBar;
Begin
  Application^.GetExtent(R);
  R.Grow(0, -1);
  TDialog.Init(R, ATitle);

  DBFile := F;
  Options  := Options or ofCentered;
  R.Grow(-1, -1);
  R.B.Y := R.A.Y + 1;
  R.Move(0, -1);
  R.Copy(Rct);
  T := New(PFieldStaticText, Init(Rct, DBFile^.GetHeader(0)));
  Insert(T);

  GetExtent(R);
  R.Grow(-1, -1);
  R.A.X := R.B.X - 1;
  Dec(R.B.Y);
  R.Move(1, 1);
  P := New(PScrollBar, Init(R));
  Insert(P);

  GetExtent(R);
  R.Grow(-1, -1);
  Inc(R.A.Y);
  LB := New(PDBListBox, Init(R, 1, P));
  Insert(LB);
End;

Procedure TDBDialog.RedrawHeader;
Begin
  Dispose(T, Done);
  T := New(PFieldStaticText, Init(Rct, DBFile^.GetHeader(Pos)));
  Insert(T);
End;

Procedure TDBDialog.HandleEvent(var Event: TEvent);
Begin
  Inherited HandleEvent(Event);
  if Event.What = evKeyDown then
  Case Event.KeyCode of
    kbLeft, kbRight: Begin
                       Pos := Pos + Event.KeyCode - kbRight + 1;
                       LB^.DrawView;
                     End;
  End;
End;

Destructor TDBDialog.Done;
Begin
  Dispose(LB, Done);
  Dispose(T, Done);
  Inherited Done;
End;

Function TDBListBox.GetText(Item, MaxLen: Integer): String;
Begin
End;

End.